ingredient_exponent = 1.07 --The exponent for increase in value for each additional ingredient forumula exponent^#ingredients
base_exponent = 1.1 --The value increase for every additional production tier or something
base_price = 3.14 --Used if a item has no recipe, for raw materials without prices defined

function generate_price_list()
price_list = {
		["iron-ore"] = 3.1,
		["copper-ore"] = 3.6,
		["coal"] = 2.1,
		["stone"] = 4.1,
		["crude-oil"] = 15.5,
		["water"] = 0.1,
		["raw-wood"] = 3.2,
		["raw-fish"] = 100,
		["alien-artifact"] = 500
}
  for k, item in pairs(game.item_prototypes) do
    loop_count = 0
    if item.type == "resource" and not price_list[name] then
      price_list[item.name] = base_price
    else
    price_list[item.name] = get_item_price(item.name)
    end
  end
  for k, item in pairs(game.fluid_prototypes) do
    loop_count = 0
    price_list[item.name] = get_item_price(item.name)
  end

  
  --This will export the price_list a human readable format

      data = "price_list =\n{\n"
      for k, v in pairs (price_list) do
      data = data.."  [\""..k.."\"] = "..0.1*math.ceil(v*10)..",\n"
      end
      data = data.."\n}"
      game.write_file("price_list.lua",data)

  global.price_list = price_list

end

function get_item_price(name)
loop_count = loop_count + 1
--game.write_file("recipe_order.txt", tostring("  "..string.rep("  ", loop_count)..name.." - "..loop_count.."\n"), true)
  if loop_count <= 100 then
    if price_list[name] then
      return price_list[name]
    else
      total_price = base_price
      if game.forces.player.recipes[name] ~= nil then  
        local total_price = game.forces.player.recipes[name].energy
        for k, ingredient in pairs (game.forces.player.recipes[name].ingredients) do
          total_price = total_price + (get_item_price(ingredient.name)*ingredient.amount)
        end
        local count = 1
        for k, product in pairs (game.forces.player.recipes[name].products) do
          if product.name == name then
            if product.amount then
              count = product.amount
            else
              count = (product.amount_max - product.amount_min)*product.probability
            end
            break
          end
        end
        if count > 0 then
          total_price = total_price*base_exponent*(ingredient_exponent^#game.forces.player.recipes[name].ingredients) / count
        end
        return total_price
      else
        local item_recipe = nil
        local found = false
        local count = 1
        for k, recipe in pairs (game.forces.player.recipes) do
          for j, product in pairs (recipe.products) do
            if product.name == name then
              found = true
              break              
            end
          end          
          if found then 
            item_recipe = recipe.name
            break
          end
        end

        if item_recipe ~= nil then
        game.write_file("found_recipes.txt", item_recipe .. "\n", true)
          local total_price = game.forces.player.recipes[item_recipe].energy
          for k, ingredient in pairs (game.forces.player.recipes[item_recipe].ingredients) do
            total_price = total_price + (get_item_price(ingredient.name)*ingredient.amount)
          end

          if not item_recipe:find("empty-") then
            if game.forces.player.recipes[item_recipe] ~= nil then
              for k, product in pairs (game.forces.player.recipes[item_recipe].products) do
                if product.name == name then
                  if product.amount then
                    count = product.amount
                  else
                    count = (product.amount_max - product.amount_min)*product.probability
                  end
                  break
                end
              end
              if count > 0 then
                total_price = total_price*base_exponent*(ingredient_exponent^(#game.forces.player.recipes[item_recipe].ingredients)) / count
              end
              return total_price
            end
          else
          total_price = base_price
          return total_price
          end
        else
        return total_price
        end
      end
    end
  else
    total_price = base_price
    return total_price
  end
price_list[name] = total_price
end


